<template>
  <div>
    <div>
<CModal
          title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Work Center Master</h5>
   
     <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
      sorter
     > 
   
 
<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectWorkCentre(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectWorkCentre(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectWorkCentre(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true">  New Work Center</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">New Work Center</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<!-- <div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-sm" placeholder="workCent Id" v-model="newWorkCentre.workCent_Id">
</div> -->

<div class="form-group"><label> Name</label>
<input type="text" name="workCent_Name" class="form-control form-control-sm"  v-model="newWorkCentre.workCent_Name">
</div>

<!-- <div class="form-group"><label>Plant Id</label>
<input type="text" name="plant_Id" class="form-control form-control-sm" placeholder="plant_Id" v-model="newWorkCentre.plant_Id">
</div> -->
<div class="form-group">
   <label for="plant_Id">Plant</label>
 <select class="form-control" v-model="newWorkCentre.plant_Id">
     <option v-for="item in pmitems" :value="item.plant_Id" :key="item.plant_Id">{{ item.plant_Name }} </option>
  </select>
</div>
<!-- <div class="form-group"><label>Work Center Type</label>
<input type="text" name="workCent_Type" class="form-control form-control-sm" placeholder="workCent_Type"  v-model="newWorkCentre.workCent_Type">
</div> -->

<div class="form-group">
   <label for="plant_Id">Work Center Type</label>
 <select class="form-control" v-model="newWorkCentre.workCent_Type">
     <option v-for="item in wctypeitems" :value="item.workCentType_Id" :key="item.workCentType_Id">{{ item.workCentType_Name }} </option>
  </select>
</div>
<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addWorkCentres();" >  Work Centre </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Work Center Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group"><label>Id</label>
<input type="text" name="workCent_Id" readonly class="form-control form-control-sm"  v-model="CurrentWorkCentre.workCent_Id">
</div>

<div class="form-group"><label>Name</label>
<input type="text" name="workCent_Name" readonly class="form-control form-control-sm"  v-model="CurrentWorkCentre.workCent_Name">
</div>

<div class="form-group"><label>Plant</label>
<input type="text" name="plant_Id" readonly class="form-control form-control-sm"  v-model="CurrentWorkCentre.plantName">
</div>

<div class="form-group"><label>Work Center Type</label>
<input type="text" name="workCent_Type" readonly class="form-control form-control-sm"   v-model="CurrentWorkCentre.workCenterName">
</div>



<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update WorkCentre</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group"><label>Id</label>
<input type="text" name="workCent_Id" readonly class="form-control form-control-sm"  v-model="newWorkCentre.workCent_Id">
</div> -->

<div class="form-group"><label>Work Center Name</label>
<input type="text" name="workCent_Name" class="form-control form-control-sm" v-model="newWorkCentre.workCent_Name">
</div>
<!-- 
<div class="form-group"><label>Plant Id</label>
<input type="text" name="plant_Id" class="form-control form-control-sm" placeholder="plant_Id" v-model="CurrentWorkCentre.plant_Id">
</div> -->
<div class="form-group">
   <label for="plant_Id">Plant</label>
 <select class="form-control" v-model="newWorkCentre.plant_Id">
     <option v-for="item in pmitems" :value="item.plant_Id" :key="item.plant_Id">{{ item.plant_Name }} </option>
  </select>
</div>

<div class="form-group">
   <label for="plant_Id">Work Center Type</label>
 <select class="form-control" v-model="newWorkCentre.workCent_Type">
     <option v-for="item in wctypeitems" :value="item.workCentType_Id" :key="item.workCentType">{{ item.workCentType_Name }} </option>
  </select>
</div>
<!-- <div class="form-group"><label>Work Center Type</label>
<input type="text" name="workCent_Type" class="form-control form-control-sm" placeholder="workCent_Type"  v-model="CurrentWorkCentre.workCenterName">
</div> -->


<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;SelectWorkCentre(CurrentWorkCentre);UpdateWorkCentres();" > Update WorkCentre </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Work Center</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Work Center ? </h4>
<h5> You are deleting {{ this.CurrentWorkCentre.workCent_Id +' || '+ this.CurrentWorkCentre.workCent_Name }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem();getAllWorkCentreDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const items = [
  //{ key: 'workCent_Id', _style:'min-width:200px' },
  { key: 'workCent_Name', _style:'min-width:100px;' },
  { key: 'PlantAdd', _style:'min-width:50px;' }, 
  { key: 'workCenterName',     _style: 'width:1%',  },
  { key: 'status',     _style: 'width:1%',  },
 ]  
 const apiwctype =  'Trace_WorkCenterType_Master/'
const apigetPlantMaster =  'Trace_Plant_Master/'
const apiurl =  'Trace_WorkCenter_Master/'
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
     
              { key: 'workCent_Name', label: 'Name', },
              { key: 'PlantAdd', label: 'Plant', },
              { key: 'workCenterName',  label: 'Type',  _style: 'width:30%', },
              { key: 'show_details',  label: '',  _style: 'width:30%', },
                    
      ],
   
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentWorkCentre:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  pmitems : "",
  wctypeitems:"",
  smallModal: false,
  newWorkCentre: {workCent_Id:0,workCent_Name:"",plant_Id:0,workCent_Type:"",status:1,}, }
  },

  
  mounted()
  {
   this.getAllWorkCentreDetails();
   this.getAllPlantMasterDetails();
   this.getAllWorkCentreTypeDetails();
  },

  methods:
  {
   getAllWorkCentreDetails: function()
   {

   Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items = response.data.filter(x => x.status == 1);
     

       }
    });
   },

   getAllPlantMasterDetails: function()
   {

   Vue.axios.get(this.$url + apigetPlantMaster)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg = response.data.message;
       }
    else
       {
        this.pmitems = response.data.filter(x => x.plant_Status == 1);
      console.log(this.pmitems);

       }
    });
   },

   getAllWorkCentreTypeDetails: function()
   {

   Vue.axios.get(this.$url + apiwctype)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.wctypeitems = response.data.filter(x => x.status == 1);
    

       }
    });
   },


   
  addWorkCentres()
  {
    
     if(this.items.find(x => x.workCent_Name == this.newWorkCentre.workCent_Name && x.status == 1 ))
    {
     this.SuccessMsg= "Work Center Name  " + this.newWorkCentre.workCent_Name +" already exist. Please try another Name";
    this.smallModal = true;
    }
     else if(this.newWorkCentre.workCent_Name ==""|| this.newWorkCentre.workCent_Type == ""|| this.newWorkCentre.plant_Id == 0)
    {
     this.SuccessMsg= " Please enter all fields";
    this.smallModal = true;
    }
    else
    {
    //  alert(this.newWorkCentre.workCentType_Id )
    Vue.axios.post(this.$url + apiurl,this.newWorkCentre).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllWorkCentreDetails();
        location.reload();
       }
    })
    }
   },

  UpdateWorkCentres()
  {  
     
      //alert(this.newWorkCentre.workCent_Name+"/" + this.newWorkCentre.workCentType +"/" +  this.newWorkCentre.plant_Id)
       if((this.CurrentWorkCentre.workCent_Name != this.newWorkCentre.workCent_Name ) && this.items.find(x => x.workCent_Name == this.newWorkCentre.workCent_Name && x.status == 1 ))
       {
         this.SuccessMsg= "Work Center Name  " + this.newWorkCentre.workCent_Name +" already exist. Please try another Name";
       this.smallModal = true;
       }
   
    else if(this.newWorkCentre.workCent_Name ==""|| this.newWorkCentre.workCent_Type == ""|| this.newWorkCentre.plant_Id == 0)
    {
       this.SuccessMsg= " Please enter all fields";
        this.smallModal = true;
    }
    else
    {
        this.newWorkCentre.workCent_Id = this.CurrentWorkCentre.workCent_Id;
      Vue.axios.put(this.$url + apiurl + this.newWorkCentre.workCent_Id, this.newWorkCentre).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllWorkCentreDetails();
          location.reload();
       }
    })
    }
   },

  deleteItem()
    {
      var workCent_Id = this.CurrentWorkCentre.workCent_Id;
        axios({   method: 'delete',
           url: this.$url + apiurl+ workCent_Id
    });
        this.SuccessMsg="WorkCentre Status Changed to Inactive Succesfully"
       this.getAllWorkCentreDetails();
        location.reload();
    },
      
  SelectWorkCentre(WorkCentre)
    {
     this.CurrentWorkCentre=WorkCentre;
     // alert(this.CurrentWorkCentre.workCent_Id)
    },
    
  
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>